﻿using Abide_AddOn_API;
using System;

namespace $safeprojectname$
{
    public class $safeprojectname$ : IAddOn
    {
        public event TagChangedEventHandler TagChanged;
        public event XboxChangedEventHandler XboxChanged;

        public string AbideVersion
        {
            get { return "1.0.0.0"; }
            // Make this match the latest version of Abide or the plugin won't have 100% compatability
        }
        public string Author
        {
            get { return "Author Name Here"; }
        }
        public string Description
        {
            get { return "AddOn Description Here"; }
        }
        public IAddOnHost Host
        {
            get
            {
                return _host;
            }
            set
            {
                _host = value;
            }
        }
        public System.Windows.Forms.UserControl Interface
        {
            get { return new UI(this); }
        }
        public string Name
        {
            get { return "AddOn Name Here"; }
        }
        public string Version
        {
            get { return "AddOn Version Here"; }
        }
        public API AddOnAPI
        {
            get { return _api; }
        }

        API _api;
        IAddOnHost _host;

        public void Initialize()
        {
            _api = new API(_host, this);
        }
        public void Dispose()
        {
            //TODO: dispose resources here
        }
        public void OnTagChanged(Tag NewTag)
        {
            OnTagChanged(new TagChangedEventArgs(NewTag));
        }
        public void OnXboxChanged(YeloDebug.Xbox NewXbox)
        {
            OnXboxChanged(new XboxChangedEventArgs(NewXbox));
        }

        protected virtual void OnTagChanged(TagChangedEventArgs e)
        {
            _api.ChangeTag(e.TagEntry);
            if (TagChanged != null)
                TagChanged(this, e);
        }
        protected virtual void OnXboxChanged(XboxChangedEventArgs e)
        {
            _api.ChangeXbox(e.XboxEntry);
            if (XboxChanged != null)
                XboxChanged(this, e);
        }

        public delegate void TagChangedEventHandler(IAddOn sender, TagChangedEventArgs e);
        public delegate void XboxChangedEventHandler(IAddOn sender, XboxChangedEventArgs e);
    }

    public class TagChangedEventArgs : EventArgs
    {
        public Tag TagEntry
        {
            get;
            protected set;
        }
        public TagChangedEventArgs(Tag changedTag)
        {
            TagEntry = changedTag;
        }
    }
    public class XboxChangedEventArgs : EventArgs
    {
        public YeloDebug.Xbox XboxEntry
        {
            get;
            protected set;
        }
        public XboxChangedEventArgs(YeloDebug.Xbox changedXbox)
        {
            XboxEntry = changedXbox;
        }
    }
}
